diff -Nru sogo-5.0.1/SoObjects/SOGo/GNUmakefile sogo-5.2.0/SoObjects/SOGo/GNUmakefile
--- sogo-5.0.1/SoObjects/SOGo/GNUmakefile	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/GNUmakefile	2021-08-18 21:35:57.000000000 +0200
@@ -21,6 +21,7 @@
 	EOBitmaskQualifier.h 		\
 	EOQualifier+SOGoCacheObject.h 	\
 	GCSSpecialQueries+SOGoCacheObject.h \
+	RTFHandler.h                    \
 	SOGoCache.h			\
 	SOGoCacheGCSFolder.h		\
 	SOGoCacheGCSObject.h		\
@@ -100,6 +101,7 @@
 	EOBitmaskQualifier.m		\
 	EOQualifier+SOGoCacheObject.m	\
 	GCSSpecialQueries+SOGoCacheObject.m \
+	RTFHandler.m                    \
 	SOGoCache.m			\
 	SOGoCacheGCSFolder.m		\
 	SOGoCacheGCSObject.m		\
diff -Nru sogo-5.0.1/SoObjects/SOGo/LDAPSource.m sogo-5.2.0/SoObjects/SOGo/LDAPSource.m
--- sogo-5.0.1/SoObjects/SOGo/LDAPSource.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/LDAPSource.m	2021-08-18 21:35:57.000000000 +0200
@@ -440,6 +440,8 @@
 - (NGLdapConnection *) _ldapConnection
 {
   NGLdapConnection *ldapConnection;
+  NSString *value, *key;
+  SOGoCache *cache;
 
   NS_DURING
     {
@@ -459,7 +461,20 @@
           if (!_schema)
             {
               _schema = [LDAPSourceSchema new];
-              [_schema readSchemaFromConnection: ldapConnection];
+              cache = [SOGoCache sharedCache];
+              key = [NSString stringWithFormat: @"schema:%@", _sourceID];
+              value = [cache valueForKey: key];
+
+              if (value)
+                {
+                  [_schema setSchema: (NSMutableDictionary *)[value objectFromJSONString]];
+                }
+              else
+                {
+                  // We go check in the LDAP directory
+                  [_schema readSchemaFromConnection: ldapConnection];
+                  [cache setValue: [_schema jsonRepresentation] forKey: key];
+                }
             }
         }
       else
@@ -718,10 +733,15 @@
                   }
                 else if (_passwordPolicy)
                   {
-                    didChange = [bindConnection changePasswordAtDn: userDN
-                                                       oldPassword: oldPassword
-                                                       newPassword: newPassword
-                                                              perr: (void *)perr];
+                    if ([bindConnection bindWithMethod: @"simple"
+                                                binddn: _sourceBindDN
+                                           credentials: _sourceBindPassword])
+                      {
+                        didChange = [bindConnection changePasswordAtDn: userDN
+                                                           oldPassword: oldPassword
+                                                           newPassword: newPassword
+                                                                  perr: (void *)perr];
+                      }
                   }
                 else
                   {
@@ -740,12 +760,20 @@
 
                     if (encryptedPass != nil)
                       {
-                        *perr = PolicyNoError;
-                        didChange = [self _ldapModifyAttribute: @"userPassword"
-                                                     withValue: encryptedPass
-                                                        userDN: userDN
-                                                      password: oldPassword
-                                                    connection: bindConnection];
+                        if ([bindConnection bindWithMethod: @"simple"
+                                                    binddn: userDN
+                                               credentials: oldPassword])
+                          {
+                            didChange = [self _ldapModifyAttribute: @"userPassword"
+                                                         withValue: encryptedPass
+                                                            userDN: userDN
+                                                          password: oldPassword
+                                                        connection: bindConnection];
+                            if (didChange)
+                              {
+                                *perr = PolicyNoError;
+                              }
+                          }
                       }
                   }
 
@@ -2028,12 +2056,12 @@
 
 - (NSArray *) membersForGroupWithUID: (NSString *) uid
 {
-  NSMutableArray *dns, *uids, *logins;
+  NSMutableArray *dns, *uids;
   NSString *dn, *login;
   SOGoUserManager *um;
   NSDictionary *d, *contactInfos;
   SOGoUser *user;
-  NSArray *o, *users;
+  NSArray *o, *subusers, *logins;
   NSAutoreleasePool *pool;
   int i, c;
   NGLdapEntry *entry;
@@ -2049,7 +2077,6 @@
       members = [NSMutableArray new];
       uids = [NSMutableArray array];
       dns = [NSMutableArray array];
-      logins = [NSMutableArray array];
 
       // We check if it's a static group
       // Fetch "members" - we get DNs
@@ -2084,8 +2111,16 @@
               user = [SOGoUser userWithLogin: login  roles: nil];
               if (user)
                 {
-                  [logins addObject: login];
-                  [members addObject: user];
+                  contactInfos = [self lookupContactEntryWithUIDorEmail: login inDomain: nil];
+                  if ([contactInfos objectForKey: @"isGroup"])
+                    {
+                      subusers = [self membersForGroupWithUID: login];
+                      [members addObjectsFromArray: subusers];
+                    }
+                  else
+                    {
+                      [members addObject: user];
+                    }
                 }
               [pool release];
             }
@@ -2101,23 +2136,22 @@
                   contactInfos = [self lookupContactEntryWithUIDorEmail: login inDomain: nil];
                   if ([contactInfos objectForKey: @"isGroup"])
                     {
-                      users = [self membersForGroupWithUID: login];
-                      [members addObjectsFromArray: users];
+                      subusers = [self membersForGroupWithUID: login];
+                      [members addObjectsFromArray: subusers];
                     }
                   else
                     {
-                      [logins addObject: login];
                       [members addObject: user];
                     }
                 }
               [pool release];
             }
 
-
           // We are done fetching members, let's cache the members of the group
           // (ie., their UIDs) in memcached to speed up -groupWithUIDHasMemberWithUID.
+          logins = [members resultsOfSelector: @selector (loginInDomain)];
           [[SOGoCache sharedCache] setValue: [logins componentsJoinedByString: @","]
-            forKey: [NSString stringWithFormat: @"%@+%@", uid, _domain]];
+                                     forKey: [NSString stringWithFormat: @"%@+%@", uid, _domain]];
         }
       else
         {
diff -Nru sogo-5.0.1/SoObjects/SOGo/LDAPSourceSchema.h sogo-5.2.0/SoObjects/SOGo/LDAPSourceSchema.h
--- sogo-5.0.1/SoObjects/SOGo/LDAPSourceSchema.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/LDAPSourceSchema.h	2021-08-18 21:35:57.000000000 +0200
@@ -1,8 +1,6 @@
 /* LDAPSourceSchema.h - this file is part of SOGo
  *
- * Copyright (C) 2011 Inverse inc
- *
- * Author: Wolfgang Sourdeau <wsourdeau@inverse.ca>
+ * Copyright (C) 2011-2021 Inverse inc
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -34,11 +32,15 @@
 
 - (void) readSchemaFromConnection: (NGLdapConnection *) conn;
 
+- (void) setSchema: (NSMutableDictionary *) newSchema;
+
 - (NSArray *) fieldsForClass: (NSString *) className;
 
 /* merged list of attributes with unique names */
 - (NSArray *) fieldsForClasses: (NSArray *) className;
 
+- (NSString *) jsonRepresentation;
+
 @end
 
 #endif /* LDAPSOURCESCHEMA_H */
diff -Nru sogo-5.0.1/SoObjects/SOGo/LDAPSourceSchema.m sogo-5.2.0/SoObjects/SOGo/LDAPSourceSchema.m
--- sogo-5.0.1/SoObjects/SOGo/LDAPSourceSchema.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/LDAPSourceSchema.m	2021-08-18 21:35:57.000000000 +0200
@@ -1,8 +1,6 @@
 /* LDAPSourceSchema.m - this file is part of SOGo
  *
- * Copyright (C) 2011 Inverse inc
- *
- * Author: Wolfgang Sourdeau <wsourdeau@inverse.ca>
+ * Copyright (C) 2011-2021 Inverse inc
  *
  * This file is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -239,6 +237,12 @@
     }
 }
 
+- (void) setSchema: (NSMutableDictionary *) newSchema
+{
+  ASSIGN (schema, newSchema);
+  [schema release];
+}
+
 static void
 fillFieldsForClass (NSMutableDictionary *schema, NSString *schemaName,
                     NSMutableArray *fields)
@@ -289,4 +293,9 @@
   return [fieldHash allKeys];
 }
 
+- (NSString *) jsonRepresentation
+{
+  return [schema jsonRepresentation];
+}
+
 @end
diff -Nru sogo-5.0.1/SoObjects/SOGo/NSData+Crypto.h sogo-5.2.0/SoObjects/SOGo/NSData+Crypto.h
--- sogo-5.0.1/SoObjects/SOGo/NSData+Crypto.h	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/NSData+Crypto.h	2021-08-18 21:35:57.000000000 +0200
@@ -60,7 +60,9 @@
 - (NSData *) asBlowfishCryptUsingSalt: (NSData *) theSalt;
 #ifdef HAVE_SODIUM
 - (NSData *) asArgon2iUsingSalt: (NSData *) theSalt;
+# ifdef crypto_pwhash_ALG_ARGON2ID13
 - (NSData *) asArgon2idUsingSalt: (NSData *) theSalt;
+#endif /* crypto_pwhash_ALG_ARGON2ID13 */
 #endif /* HAVE_SODIUM */
 
 - (NSData *) extractSalt: (NSString *) theScheme;
diff -Nru sogo-5.0.1/SoObjects/SOGo/NSString+Utilities.m sogo-5.2.0/SoObjects/SOGo/NSString+Utilities.m
--- sogo-5.0.1/SoObjects/SOGo/NSString+Utilities.m	2020-10-07 17:11:26.000000000 +0200
+++ sogo-5.2.0/SoObjects/SOGo/NSString+Utilities.m	2021-08-18 21:35:57.000000000 +0200
@@ -309,9 +309,10 @@
       if (c == 0x0 ||
 	  c == 0x9 ||
           c == 0xA ||
-          c == 0xD ||
-          (c >= 0x20 && c <= 0xD7FF) ||
-          (c >= 0xE000 && c <= 0xFFFD) ||
+          (c >= 0x20 && c < 0x300) || // Skip combining diacritical marks
+          (c > 0x36F && c < 0xD7FF) ||
+          (c >= 0xE000 && c < 0xFE00) || // Skip variation selectors
+          (c > 0xFE0F && c <= 0xFFFD) ||
           (c >= (wchar_t)0x10000 && c <= (wchar_t)0x10FFFF))
         {
           start[j] = c;
@@ -436,7 +437,7 @@
   NSString *cleanedString;
 
   // Escape double quotes and remove control characters
-  cleanedString = [[self doubleQuotedString] safeString];
+  cleanedString = [[self safeString] doubleQuotedString];
   return cleanedString;
 }
 
diff -Nru sogo-5.0.1/SoObjects/SOGo/RTFHandler.h sogo-5.2.0/SoObjects/SOGo/RTFHandler.h
--- sogo-5.0.1/SoObjects/SOGo/RTFHandler.h	1970-01-01 01:00:00.000000000 +0100
+++ sogo-5.2.0/SoObjects/SOGo/RTFHandler.h	2021-08-18 21:35:57.000000000 +0200
@@ -0,0 +1,141 @@
+/*
+  Copyright (C) 2005-2012 Inverse inc.
+
+  This file is part of SOGo.
+
+  SOGo is free software; you can redistribute it and/or modify it under
+  the terms of the GNU Lesser General Public License as published by the
+  Free Software Foundation; either version 2, or (at your option) any
+  later version.
+
+  SOGo is distributed in the hope that it will be useful, but WITHOUT ANY
+  WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+  License for more details.
+
+  You should have received a copy of the GNU Lesser General Public
+  License along with OGo; see the file COPYING.  If not, write to the
+  Free Software Foundation, 59 Temple Place - Suite 330, Boston, MA
+  02111-1307, USA.
+*/
+
+#include <Foundation/NSArray.h>
+#include <Foundation/NSData.h>
+#include <Foundation/NSMapTable.h>
+#include <Foundation/NSObject.h>
+#include <Foundation/NSString.h>
+
+//
+//
+//
+@class RTFFontTable;
+
+@interface RTFHandler : NSObject
+{
+  NSMapTable *_charsets;
+  NSMutableData *_html;
+  NSData *_data;
+
+  const char *_bytes;
+  int _current_pos;
+  int _len;
+}
+
+- (id) initWithData: (NSData *) theData;
+- (NSMutableData *) parse;
+
+- (RTFFontTable *) parseFontTable;
+- (void) mangleInternalStateWithBytesPtr: (const char*) newBytes
+                          andCurrentPos: (int) newCurrentPos;
+
+@end
+
+//
+//
+//
+@interface RTFStack: NSObject
+{
+  NSMutableArray *a;
+}
+- (void) push: (id) theObject;
+- (id) pop;
+@end
+
+//
+//
+//
+@interface RTFFormattingOptions : NSObject
+{
+@public
+  BOOL bold;
+  BOOL italic;
+  BOOL underline;
+  BOOL strikethrough;
+  int font_index;
+  int color_index;
+  int start_pos;
+  const unsigned short *charset;
+}
+@end
+
+//
+//
+//
+@interface RTFFontInfo : NSObject
+{
+@public
+  NSString *family;
+  unsigned char charset;
+  NSString *name;
+  unsigned int pitch;
+  unsigned int index;
+}
+
+- (NSString *) description;
+@end
+
+//
+// \fX - font, index in font table
+//
+@interface RTFFontTable : NSObject
+{
+  @public
+  NSMapTable *fontInfos;
+}
+
+- (void) addFontInfo: (RTFFontInfo *) theFontInfo
+             atIndex: (unsigned int ) theIndex;
+- (RTFFontInfo *) fontInfoAtIndex: (unsigned int ) theIndex;
+- (NSString *) description;
+
+@end
+
+//
+//
+//
+@interface RTFColorDef : NSObject
+{
+@public
+  unsigned char red;
+  unsigned char green;
+  unsigned char blue;
+}
+
+@end
+
+//
+// {\colortbl\red0\green0\blue0;\red128\green0\blue0;\red255\green0\blue0;}
+//
+// \cfX - color/foreground - index
+// \cbX - color/background - index
+//
+//
+@interface RTFColorTable : NSObject
+{
+  @public
+  NSMutableArray *colorDefs;
+}
+
+- (void) addColorDef: (RTFColorDef *) theColorDef;
+
+@end
